unit Unit1;
{ ,      }
{ default    ,  }
{    . }
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TDefaultIntProperty = class
    private
      FInt : Integer;
      procedure SetDefaultIntProperty (Value : Integer);
    public
      property DefaultIntProperty : Integer read FInt
            write SetDefaultIntProperty default 10; { default   10, }
                         {  Fint    0 ! }
  end;

  TDefaultBoolProperty = class
    private
      FBool : Boolean;
      procedure SetDefaultBoolProperty (Value : Boolean);
    public
      property DefaultBoolProperty : Boolean read FBool
            write SetDefaultBoolProperty default True; { default   True, }
            {   FBool    False ! }
   end;

var
  Form1: TForm1;
  MyIntVar : TDefaultIntProperty;
  MyBoolVar : TDefaultBoolProperty;
  St : String;

implementation

{$R *.dfm}

procedure TDefaultIntProperty.SetDefaultIntProperty;
begin
  FInt := Value
end;

procedure TDefaultBoolProperty.SetDefaultBoolProperty;
begin
  FBool := Value
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyIntVar := TDefaultIntProperty.Create;
  Str (MyIntVar.DefaultIntProperty, St);
  Form1.Memo1.Lines.Add(St);
  MyIntVar.Free;

  MyBoolVar := TDefaultBoolProperty.Create;
  If MyBoolVar.DefaultBoolProperty then
        Form1.Memo1.Lines.Add( 'True' )
  else Form1.Memo1.Lines.Add( 'False' );
  MyBoolVar.Free;
end;

end.
